function get_mindy_list_pv_dist(parami,paraml,paramo_postprocessing)

outdir = paramo_postprocessing;
[data textdata] = importfile(parami);
affyid = textdata(2:end,1);
genesymbol = textdata(2:end,2);
clear data textdata

tfaffy = textread(paraml,'%s');

fname = 'bcell_mod_q0.35_mip1e-6_e0.1_264samples_postprocessing_bf_nogenes';
outpath = [outdir '/'];
outfile3 = [outpath outdir '_summ.txt'];


disp('Creating distribution file')
% print combined (multiple probe TF) & unique gene count
out3 = fopen(outfile3,'w');
fprintf(out3,'%s\t%s\t%s\t%s\t%s\n','Msym','Fsym','Biological_mode','Gnum','Mode');
fsym={};
for i=1:length(tfaffy)
    fsym = [fsym; genesymbol(find(strcmp(tfaffy(i),affyid)))];
end
fsymuq = unique(fsym);

for i=1:length(fsymuq)
    i
    fix = strmatch(fsymuq(i),fsym,'exact');
    msym={}; gsym={}; mdat=[]; mbio = [];
    for j=1:length(fix)
        outfile1 = [outpath 'mindy_' tfaffy{fix(j)} '.txt'];
        [T.maffy T.msym T.faffy T.fsym T.gaffy T.gsym tmp] = textread(...
            outfile1,'%s%s%s%s%s%s%[^\n]','delimiter','\t','headerlines',1);
        msym = [msym; T.msym];
        gsym = [gsym; T.gsym];
        if ~isempty(T.msym)
            T.data = dlmread(outfile1,'\t',1,6);
            mdat = [mdat; T.data];
        end
    end
    msymuq = unique(msym);
    for j=1:length(msymuq)
        ixtg = ismember(msym,msymuq(j));
        gsymuq = unique(gsym(ixtg));
        mode = sum(mdat(ixtg,1));
        total_bmode = length(mdat(ixtg,3));
        bmode_pos = length(find((mdat(ixtg,3)==1)));
        bmode_neg = length(find((mdat(ixtg,3)==-1)));
        bmode_zero = length(find((mdat(ixtg,3)==0)));

        if bmode_zero>= .5*total_bmode
            bmode = 'U';
        else if bmode_pos >= 1.3*bmode_neg
                bmode = '+';
            else if bmode_neg >= 1.3*bmode_pos
                    bmode = '-';
                else
                    bmode = 'U';
                end
            end
        end
        fprintf(out3,'%s\t%s\t%s\t%d\t%d\n',msymuq{j},fsymuq{i},bmode,length(gsymuq),sign(mode));
    end
end
fclose(out3);
