function result=hasSeparatedTails(data,percent,alpha);

if nargin<3
    alpha = 0.05;
end

[n,m] = size(data);
if percent==0   % include everything
    result = ones(n,1);
    return;
end

k      = floor(m*percent);
result = zeros(n,1);
for i=1:n
    [foo I] = sort(data(i,:));
    lo  = log(data(i,I(k)));
    hi  = log(data(i,I(m-k+1)));
    s   = sqrt(4.6*(exp(-1.1*hi)+exp(-1.1*lo)));
    p   = 1-normcdf((hi-lo)/s);
    if (p <= alpha)
        result(i) = 1;
    end
end
return;
