function posrptocess_cindy(jobid)
load mindy_postprocessing_parameters

%%%%%%%%%% Reading parameters for CMI palue %%%%%%%%%%
fid = fopen('pvalue.m');
contents = textscan(fid,'%s','delimiter','\n');
fclose(fid);
contents = contents{1};
cline = strmatch('a = [',contents);
temp = contents{cline};
temp = strrep(temp,'a = [','');
temp = strrep(temp,'];','');
parameters_deltaI(:,1) = strread(temp,'%f','delimiter',';');

cline = strmatch('b = [',contents);
temp = contents{cline};
temp = strrep(temp,'b = [','');
temp = strrep(temp,'];','');
parameters_deltaI(:,2) = strread(temp,'%f','delimiter',';');

cline = strmatch('n = [',contents);
temp = contents{cline};
temp = strrep(temp,'n = [','');
temp = strrep(temp,'];','');
parameters_deltaI(:,3) = strread(temp,'%f','delimiter',';');

cline = strmatch('t = [',contents);
temp = contents{cline};
temp = strrep(temp,'t = [','');
temp = strrep(temp,'];','');
parameters_deltaI(:,4) = strread(temp,'%f','delimiter',';');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tfaffy = textread(file_tflist,'%s');
if use_network
    [tfs targets ~] = textread(network_file,'%s%s%s','delimiter','\t');
    tf_targets = targets(find(strcmp(tfs,tfaffy(str2num(jobid)))));
end

outfile = [paramo_postprocessing '/mindy_' char(tfaffy(str2num(jobid))) '.mat'];
if (~exist(outfile,'file'))
    
    [data textdata] = importfile(paramc);
    datadb = data;
    dbaffy = textdata(2:end,1);
    db_genes_names = textdata(2:end,2);
    clear data textdata
    
    [data textdata] = importfile(filename_exp);
    siggeneaffy = textdata(2:end,1);
    gep.data = data;
    gep.affyid = textdata(2:end,1);
    gep.symbol = textdata(2:end,2);
    
    disp(['processing hub (' num2str(length(tfaffy)) '): ' ]);
    buffer = ' ';
    %for i=1:length(tfaffy)
    i = str2num(jobid)
    
    hub = tfaffy{i};
    % disp('Reading MINDY results ... ');
    cam_file = [paramo '/' hub '.cmm'];
    cmm_file = [paramo '/' hub '.cmm'];
    system(['bunzip2 ' char(cmm_file) '.bz2']);
    %system(['bunzip2 ' char(cam_file) '.bz2']);
    [edges,foo]=textread(cam_file,'%s%[^\n]','delimiter','\t','headerlines',1,'bufsize',2620800);
    [foo,bar,header] = textread(cam_file,'%s%s%[^\n]',1,'delimiter','\t','bufsize',2620800);
    conditions = strread(header{1},'%s','delimiter','\t');
    clear header;
    candidate_target = edges;
    
    candidates = conditions;
    candidate_modulator = candidates;
    
    mi_hub_mod =nan(size(candidates));
    id_tf = strcmp(gep.affyid,tfaffy(i));
    for j = 1:length(candidates)
        temp = find(strcmp(dbaffy,candidates(j)));
        mi_hub_mod(j) = mutualinfo_ap([datadb(temp,:);gep.data(id_tf,:)]');
    end
    
    
    % the first column of both matrices is the unconditional MI
    temp    = single(dlmread(cam_file,'\t',1,1));
    mi      = temp(:,1);
    cmm     = temp(:,2:size(temp,2));
    clear temp;
    %cmm     = single(dlmread(cmm_file,'\t',1,2));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %   Select candidate modulators
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % make sure that rows in CAM are in the same order as those in the EXP
    
    if(use_network==0)
        [Z,IX,IY] = intersect(gep.affyid,edges);
        if sum(IX-(1:length(IX))')~=0
            error('Data format does not match!');
        end
        score = cmm;
    else
        [a,b,c] = intersect(tf_targets,edges);
        score = cmm(c,:);
        candidate_target    = edges(c);
        mi = mi(c);
    end
    
    direct  = abs(sign(cmm));
    
    pv      = pvalue_deltaI(parameters_deltaI(:,1),parameters_deltaI(:,2),parameters_deltaI(:,3),parameters_deltaI(:,4),mi,score);
    
    % Bonferroni correction
    if stringency
        ncorr   = sum(sum(direct));
    else
        ncorr   = length(find(sum(direct')));
    end
    %ncorr = sum(sum(direct));
    map     = (pv <= (p_discover/ncorr));
    cids    = find(sum(map,1));
    rids    = find(sum(map,2));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %   Output results
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    if ~isempty(map)
        result = map.*score;
    else
        result = [];
    end
    
    ms.data      = result(rids,cids);
    ms.pv        = pv(rids,cids);
    % clear map result pv pv_corr;
    
    % get target annotation and correlation with the hub
    target.affyid      = candidate_target(rids);
    [C,IA,IB]          = intersect(target.affyid,gep.affyid);
    [IC,I]             = sort(IA);
    idx                = IB(I);
    target.symbol      = gep.symbol(idx);
    hid                = strmatch(hub,gep.affyid,'exact');
    target.correlation = corr(gep.data(hid,:)', gep.data(idx,:)')';
    
    % get modulator annotation and mutual information with the hub
    modulator.affyid     = candidate_modulator(cids);
    if strcmp(filename_exp,filename_mod_data)
        [C,IA,IB]            = intersect(modulator.affyid,gep.affyid);
        [IC,I]               = sort(IA);
        modulator.symbol     = gep.symbol(IB(I));
        [C IA IB]            = intersect(modulator.affyid,edges);
        [IC I]               = sort(IA);
        modulator.mutualinfo = mi(IB(I));
    else
        [C,IA,IB]            = intersect(modulator.affyid,dbaffy);
        [IC,I]               = sort(IA);
        modulator.symbol     = db_genes_names(IB(I));
        [C IA IB]            = intersect(modulator.affyid,candidates);
        [IC I]               = sort(IA);
        modulator.mutualinfo = mi_hub_mod(IB(I));
    end
    % clear rids cids edges candidates;
    ms.target    = target;
    ms.modulator = modulator;
    
    info.hub            = hub;
    info.ncandidate     = length(candidate_modulator);
    info.neighborhood   = length(candidate_target);
    info.percent        = percent;
    info.p_independ     = p_independ;
    info.p_dynamics     = p_dynamics;
    info.p_discover     = p_discover;
    ms.info             = info;
    
    eval(['save ' paramo_postprocessing '/mindy_' hub '.mat ms']);
    system(['bzip2 ' char(cmm_file)]);
    %system(['bzip2 ' char(cam_file)]);
    
end


function p = pvalue_deltaI(a,b,n,t,mi,cmi);

if isempty(mi)
    p = [];
    return;
end

if (~isvector(mi) | size(mi,1)<size(mi,2))
    error('MI must be a column vector!');
end

if length(mi)~=size(cmi,1)
    error('Conditional MI matrix must have same number of rows as the MI vector!');
end

c = zeros(length(mi),1);
for i=1:length(c)
    j = 1;
    while (j<100 & mi(i)>=t(j))
        j = j+1;
    end
    c(i) = j;
end
idx = c*ones(1,size(cmi,2));
if length(mi) ==1
    a = a';
    b = b';
    n = n';
    t = t';
    p = 10.^(b(idx)-a(idx).*(abs(cmi).^n(idx)));
else
    p = 10.^(b(idx)-a(idx).*(abs(cmi).^n(idx)));
end
