[data,dataid] = readTestData('arraydata10x336.exp');

[cand,candid] = readTestData('candidate_modulator.exp');

hub  = 'G2';
q    = 0.35;
type = 'spearman'; 
hid  = strmatch(hub,dataid,'exact');

score = zeros(length(dataid),length(candid)*2);
buffer = ' ';
disp('Processing candidate modulator ... ');
for i=1:length(candid)
    disp([repmat(char(8),1,length(buffer)) candid{i}]);
    buffer = [candid{i} ' '];    
    if strcmp(candid{i},hub)==0
        mid = strmatch(candid{i},candid,'exact');
        for j=1:length(dataid)
            if strcmp(dataid{j},hub)==0 && strcmp(dataid{j},candid{i})==0
                tid = strmatch(dataid{j},dataid,'exact');
                score(j,2*i-1)  = calCondCorr(data(hid,:)',data(tid,:)',cand(mid,:)',type,-q);
                score(j,2*i)    = calCondCorr(data(hid,:)',data(tid,:)',cand(mid,:)',type,q);
            end
        end
    end
end

mindy = readMINDyResult(['arraydata10x336_h' hub '_p' num2str(q) '.cmm']);

score_str = mat2str(score,6);
mindy_str = mat2str(mindy,6);

foo = strcmp(score_str,mindy_str);
if foo==1
    disp('Computations are the same!');
else
    disp('Computations differ!');
end

