addpath X:/project/matlab_toolbox/mutualinfo/;

[data,dataid] = readTestData('arraydata10x336.exp');

[cand,candid] = readTestData('candidate_modulator.exp');

ma   = size(data,2);
hub  = 'G5';
q    = 0.45;
type = 'spearman'; 
hid  = strmatch(hub,dataid,'exact');

ss = round(q*ma);
dn = 1:ss;
up = (ma-ss+1):ma;
h  = getKernelWidth(ss);

score = zeros(length(dataid),length(candid)*2);
buffer = ' ';
disp('Processing candidate modulator ... ');
for i=1:length(candid)
    disp([repmat(char(8),1,length(buffer)) candid{i}]);
    buffer = [candid{i} ' '];    
    if strcmp(candid{i},hub)==0
        mid = strmatch(candid{i},candid,'exact');
        [foo,I] = sort(cand(mid,:));
        for j=1:length(dataid)
            if strcmp(dataid{j},hub)==0 && strcmp(dataid{j},candid{i})==0
                tid = strmatch(dataid{j},dataid,'exact');
                score(j,2*i-1) = mutualinfo(data(hid,I(dn)),data(tid,I(dn)),h);
                score(j,2*i)   = mutualinfo(data(hid,I(up)),data(tid,I(up)),h);
            end
        end
    end
end

outfile = 'arraydata10x336_hG5_k0.157_p0.45.cmm';
mindy   = readMINDyResult(outfile);

score_str = mat2str(score,6);
mindy_str = mat2str(mindy,6);

foo = strcmp(score_str,mindy_str);
if foo==1
    disp('Computations are the same!');
else
    disp('Computations differ!');
end

