#!/usr/bin/perl
# This script will run the MINDY program on ADCLUSTER
#
# Usage: perl qsub_mindy <file containing list of TFs> <other MINDY paramters>
#
# Example: perl MINDY hub_list.dat -i microarray.exp -c conditions.dat -p 0.35 -k 0.15 -e 0.10 -t 0.08 -l subnet_nodes.dat
#
# Author: Kai Wang

use warnings;
use strict;

my $msg = `qstat -u kw2110 | grep Eqw`;
my @jobs = split "\n",$msg;

my @pid = ();
foreach (@jobs) {
	/\s(\d+)(\s+)/;
	push @pid, $1;
}

my $njobs = scalar(@pid);
print "No. of jobs with EQW status: $njobs\n";

foreach (@pid) {
	print "Killing pending job : $_\n";	
	$msg = `qstat -j $_ | grep script_file`;
	$msg =~ /\s+(\S+)$/;
	print "Resubmitting job    : $1\n";
}

